/*=================================================================*/
/*    drws.c : A sample program for DRWS                           */
/*=================================================================*/
#include <stdio.h>
#include "random_sampler.h"

#define SAMPLE_SIZE  1000000

int main()
{
   unsigned long halfmax = RANDMAX >> 1;
   long i;
   int number_of_heads, f;
   double sum_of_f;

   m90setseeds(0,53,0,0,0);
   init_drws();

   sum_of_f=0.0;
   for ( i=1; i <= SAMPLE_SIZE; i++ ){
      number_of_heads=0;
      f=0;
      set_first_location();
      while ( number_of_heads < 5 ){
         f++;
         if ( drws31() >= halfmax ) number_of_heads++;
      }
      sum_of_f += f;
   }
   printf("Mean of hitting time = %f\n", sum_of_f/SAMPLE_SIZE);
   printf("locmax = %d\n", get_locmax());
   end_drws();
   return 0;
}
/*================ End of drws.c ==================================*/