/*==========================================================*/
/*  file name: rws_S500.c                                   */
/*==========================================================*/
#include <stdio.h>
#include "random_sampler.h"

#define SAMPLE_NUM 10000000
#define M          500
#define M_PLUS_J   523

int  x[M_PLUS_J], a[M_PLUS_J], hist[M+1];

void longadd(void)   /* x = x + a ( long digit addition ) */
{
 int i, s, carry = 0;
 for ( i = M_PLUS_J-1; i >= 0; i-- ){
   s = x[i] + a[i] + carry;
   if ( s >= 2 ) {carry = 1; s = s - 2; } else carry = 0;
   x[i] =  s;
 }
}

int s500(void)
{
 int s = 0, i;
 for ( i = 0; i <= M-1; i++ ) s += x[i];
 return s;
}

int main()
{
 int n,i;

 m90setseeds(664426,5161592,7773372,84171419,1545);
 for( i = 0; i <= M ; i++ ) hist[i] = 0;
 for( i = 0; i <= M_PLUS_J-1; i++ ) x[i] = m90randombit();
 for( i = 0; i <= M_PLUS_J-1; i++ ) a[i] = m90randombit();

 for ( n = 1 ; n <= SAMPLE_NUM ; n++ ){
  longadd();
  hist[s500()]++;
  if ( n == 1000 || n == 10000 || n == 100000 || n == 10000000 ){
   printf ("%d samples:\n",n);
   for( i = 0; i <= M ; i++ )
    printf ( "%3d : %8.7f\n", i,(double)hist[i]/(double)n);
   printf ("\n");
  }
 }
 return 0;
}
/*================ End of rws_S500.c ====================*/