/*==========================================================*/
/*  file name: rws_example.c                                */
/*==========================================================*/
#include <stdio.h>

#define SAMPLE_NUM 1000000
#define M          100
#define M_PLUS_J   119

/* seed */
char xch[] = 
   "1110110101" "1011101101" "0100000011" "0110101001" "0101000100"
   "0101111101" "1010000000" "1010100011" "0100011001" "1101111101"
   "1101010011" "111100100";
char ach[] = 
   "1100000111" "0111000100" "0001101011" "1001000001" "0010001000" 
   "1010101101" "1110101110" "0010010011" "1000000011" "0101000110"
   "0101110010" "010111111";

int  x[M_PLUS_J], a[M_PLUS_J];

void longadd(void)   /* x = x + a ( long digit addition ) */
{
 int i, s, carry = 0;
 for ( i = M_PLUS_J-1; i >= 0; i-- ){
   s = x[i] + a[i] + carry;
   if ( s >= 2 ) {carry = 1; s = s - 2; } else carry = 0;
   x[i] =  s;
 }
}

int maxLength(void)  /* count the longest run of 1's */
{
 int len = 0, count = 0, i;
 for ( i = 0; i <= M-1; i++ ){
  if ( x[i] == 0 ){ if ( len < count ) len = count; count = 0;}
  else count++ ;  /*  if x[i]==1 */
 }
 if ( len < count ) len = count;
 return len;
}

int main()
{
 int n, s = 0;
 for( n = 0; n <= M_PLUS_J-1; n++ ){
  if( xch[n] == '1' ) x[n] = 1; else x[n] = 0;
  if( ach[n] == '1' ) a[n] = 1; else a[n] = 0;
 }
 for ( n = 1 ; n <= SAMPLE_NUM ; ++n ){
  longadd();
  if ( maxLength() >= 6 ) s++;
 }
 printf ( "s=%6d, p=%7.6f\n", s, (double)s/(double)SAMPLE_NUM);
 return 0;
}
/*================ End of rws_example.c ===================*/